// Structure definition and function templates for GRF files

struct grfHeader
{
	unsigned long grfSig;
	unsigned long fileSize;
	unsigned long numDDEs;
	unsigned long numNTEs;
	unsigned long sizeNamTab;
	unsigned long offNamTab;
	unsigned long unknown1;
	unsigned long unknown2;
	unsigned long unknown3;
	unsigned long unknown4;
	unsigned long unknown5;
	unsigned long unknown6;
};

struct ddEntry
{
	unsigned long ddeTag;
	unsigned long unknown1;
	unsigned long dataOffset;
	unsigned long dataLength;
	unsigned long unknown2;
	unsigned long unknown3;
	unsigned long dataType;
	unsigned short count;
	unsigned short unknown4;
};

struct ntEntry
{
	unsigned long nteTag;
	unsigned long strLength;
	unsigned long unknown1;
	         char *string;
};

class GrfFile
{
public:
	GrfFile();
	~GrfFile();
	bool InitGrf (char * grfFileName);
	bool ReadGrfBlock  (unsigned long blockNum, char * &name, char * &data,
						unsigned long & datalen);
	unsigned long NumDataBlocks();
	unsigned long NumNameBlocks();
	unsigned long GetNTNum(unsigned long block);
	bool GetBlockName(unsigned long block, char * &name);
	ddEntry * GetDDE(unsigned long block);
	
private:
	FILE * grfFile;
	grfHeader header;
	ddEntry * ddTable;
	ntEntry * namTable;
	unsigned long * ntNums;
};
