// GRFHack 0.10.  Modified Developer only beta version ;P
// Gets all the blocks out of uncompressed GRF, SCN, or
// savegame files. Thinks it names them correctly. Doesn't
// deal with the extra NameTable info in the GRFs yet.

// by Iguanaman... "Making Hacking a Little Easier"
// 01-28-1999	-- 0.09B
// To be added:
//		The usual (editing, decoding, etc...)

// updated 01-30-1999 by PenguiN -- 0.09C
//  fixed an unimportant memory leak somewhere ( delete instead of delete [] )
//  fixed problem of getting one too many data blocks.
//  added SCN File Data type
//  Added GetNTNum function, changed GetBlockName, ReadGrfBlock, and 
//		ExtractBlockRange to get and output the correct block names.
//	Made ntNums table to speed up GetNTNum function.
//	random fixings, version # changed
//
// updated 02-05-1999 by PenguiN -- 0.10
//	PASS GRFFILE BY REFERENCE!!!! FIX "EVIL BUG"

#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <iomanip.h>
#include <string.h>
#include "grfhack.h"

///////////////////////////////////////////////////////////////////////////////
char Menu()
{
	char c;
	
	cout << endl;
	cout << "Please enter your choice: " << endl;
	cout << endl;
	cout << "(V)iew Block Information" << endl;
	cout << "Extract (s)ingle block" << endl;
	cout << "Extract (m)ultiple blocks" << endl;
	cout << "Extract (a)ll blocks you sick puppy" << endl;
	cout << "(Q)uit" << endl;
	cout << "Please make a selection: " << endl;

	c = toupper(_getch());
	return c;
}
///////////////////////////////////////////////////////////////////////////////
unsigned long ChooseBlock(unsigned long min, unsigned long max, char * why)
{
	unsigned long temp;
	temp = min-1;
	while ( (temp < min) || (temp > max) )
	{
		cout << "Please enter " << why << " block number between "
			 << min << " and " << max << endl;
		_getch();
		cin >> temp;

		if (temp < min)
			cout << "Too Small, Try Again." << endl;
		else if (temp > max)
			cout << "Too Large, Try Again." << endl;
	}
	
	return temp;
}
///////////////////////////////////////////////////////////////////////////////
void ViewBlockInfo(GrfFile & bob)
{
	char * temp;
	char choice;
	bool loop;
	unsigned long junk = 0;
	ddEntry * dde;
	unsigned long block;
	
	temp = new char[80];

	block = ChooseBlock(0, bob.NumDataBlocks() - 1, "a");
		
	loop = true;

	while (loop)
	{
		dde = bob.GetDDE(block);
		cout << endl;
		cout << "Information for block " << block << endl;
		cout << "DDE Tag:     0x" << setfill('0') << setw(10)
			 << _itoa(dde->ddeTag,temp, 16) << endl;
		cout << "Unknown1:    0x" << setfill('0') << setw(10)
			 << _itoa(dde->unknown1, temp, 16) << endl;
		cout << "Data Offset: 0x" << setfill('0') << setw(10)
			 << _itoa(dde->dataOffset, temp, 16) << endl;
		cout << "Data Length: 0x" << setfill('0') << setw(10)
			 << _itoa(dde->dataLength, temp, 16) << endl;
		cout << "Unknown2:    0x" << setfill('0') << setw(10)
			 << _itoa(dde->unknown2, temp, 16) << endl;
		cout << "Unknown3:    0x" << setfill('0') << setw(10)
			 << _itoa(dde->unknown3, temp, 16) << endl;
		cout << "Data Type:   ";
		switch(dde->dataType)
		{
		case 0x0001:
			cout << "Header";
			break;
		case 0x0002:
			cout << "Region";
			break;
		case 0x0004:
			cout << "Name";
			break;
		case 0x0008:
			cout << "Geometry";
			break;
		case 0x0010:
			cout << "Mapping";
			break;
		case 0x0020:
			cout << "Material";
			break;
		case 0x2000:
			cout << "Value Table";
			break;
		case 0x80000000:
			cout << "SCN File Data";
			break;
		default:
			cout << "Who knows!";
			break;
		};
	
		cout << endl;
		cout << "Count:       0x" << setfill('0') << setw(10) << dde->count << endl;
		cout << "Unknown4:    0x" << setfill('0') << setw(10)
			 << _itoa(dde->unknown4, temp, 16) << endl;
		bob.GetBlockName(block, temp);
		cout << "Name         " << temp << endl;
		cout << endl;
		cout << "(P)revious, (N)ext, or press any key to stop" << endl;
	
		choice = toupper(getch());
		
		switch (choice)
		{
		case 'P':
			if (block > 0)
				block--;
			break;
		case 'N':
			if (block < bob.NumDataBlocks() - 1)
				block++;
			break;
		default:
			loop = false;
			break;
		};
	}

}
///////////////////////////////////////////////////////////////////////////////
bool ExtractBlockRange(GrfFile & bob, unsigned long startNum, unsigned long endNum)
{
	FILE *curFile;
	char *data, *tempName;
	unsigned long dataLen;
	unsigned long count;
	char pathName[512], fileName[512];
	int pathLen;
	char *LastNameEntry;
	const char DefaultNameEntry[] = "default";
	ddEntry * dde;

	cout << "Please enter the path where I should extract files: " << endl;
	_getch();
	cin >> pathName;
	cout << endl;

	pathLen = strlen(pathName);
	if (pathName[pathLen-1] != '\\')
	{
		pathName[pathLen] = '\\';
		pathName[pathLen+1] = '\0';
	}
	
	LastNameEntry = new char [strlen(DefaultNameEntry) + 1];
	strcpy(LastNameEntry, DefaultNameEntry);

	for (count = startNum; count <= endNum; count++)
	{

		dde = bob.GetDDE(count);

		if (!bob.ReadGrfBlock(count, tempName, data, dataLen))
			return false;

		if (tempName[0] == '\0')
	
		{
			_itoa(count, tempName, 10);
		}
		
		strcpy(fileName, pathName);

		switch(dde->dataType)
		{
		case 0x0001:	/* header, region, or valuetable */
		case 0x0002:	
		case 0x2000:
			strcat(fileName, DefaultNameEntry);
			break;
		case 0x0004:	/* name */
			delete [] LastNameEntry;
			LastNameEntry = new char [strlen(tempName) + 1];
			strcpy(LastNameEntry, tempName);
			break;
		case 0x0008:	/* geometry, mapping, material */
		case 0x0010:
		case 0x0020:
			strcat(fileName, LastNameEntry);
			break;
		default:
			if (tempName[0] == '.')
				strcat(fileName, DefaultNameEntry);
		}

		strcat(fileName, tempName);

		delete tempName;	// Reclaim memory

		cout << fileName << endl;

		curFile = fopen(fileName, "wb");
		if (curFile)
		{
			if (!fwrite(data, dataLen, 1, curFile))
				return false;
			
			fclose(curFile);
		}
		else
		{
			cout << "Problem creating file " << fileName << endl;
		}

		delete data;
	}

	return true;
}
///////////////////////////////////////////////////////////////////////////////
void ExtractSingle(GrfFile & bob)
{
	unsigned long block;

	block = ChooseBlock(0, bob.NumDataBlocks() - 1, "a");
	ExtractBlockRange(bob, block, block);
}
///////////////////////////////////////////////////////////////////////////////
void ExtractMultiple(GrfFile & bob)
{
	unsigned long min, max;
	
	min = ChooseBlock(0, bob.NumDataBlocks() - 1, "starting");
	max = ChooseBlock(0, bob.NumDataBlocks() - 1, "ending");
	ExtractBlockRange(bob, min, max);
}
///////////////////////////////////////////////////////////////////////////////
void ExtractAll(GrfFile & bob)
{
	ExtractBlockRange(bob, 0, bob.NumDataBlocks() - 1);
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
void main(int argc, char * argv[])
{
	GrfFile bob;
	char temp1 = 'G';

	if (argc != 2)
	{
		cout << "Usage: GRFHACK <GRFFILE>" << endl;
		_getch();
		exit(1);
	}

	if (!bob.InitGrf(argv[1]))
	{
		cout << "Problem during initialization (?Bad GRF File?)" << endl;
		_getch();
		exit(1);
	}

	cout << "Welcome to GRFHack 0.10 by Iguanaman and PenguiN42 **1999**" << endl;
	cout << endl;
	
	while (temp1 != 'Q')
	{
		temp1 = Menu();
		switch (temp1)
		{
		case 'V':
			ViewBlockInfo(bob);
			break;
		case 'S':
			ExtractSingle(bob);
			break;
		case 'M':
			ExtractMultiple(bob);
			break;
		case 'A':
			ExtractAll(bob);
			break;
		};
	}
}



