#include <stdio.h>
#include <math.h>
#include "tpahack.h"

// thefile has to be opened for binary reading, biatch.

// no error checking other than is_good_tpa yet... sorry.

//size_t fread( void *buffer, size_t size, size_t count, FILE *stream );
//int fseek( FILE *stream, long offset, int origin );

int is_good_tpa(FILE *thefile)
{
	int isgood = 0;
	if (thefile == NULL)
		isgood = 0;
	else
	{
		char tag[4];
		fseek(thefile, 0, SEEK_SET);
		fread(tag, sizeof(char), 4, thefile);

		if (tag[0]==80 && tag[1]==1 && tag[2]==0 &&tag[3]==0)
			isgood = 1;
		else
			isgood = 0;
	}

	return isgood;
}

//size_t fread( void *buffer, size_t size, size_t count, FILE *stream );
int load_tpa_data(FILE *thefile, struct TPAFILE *thedata)
{
	fseek(thefile, 0, SEEK_SET);

	fread( thedata->tag, sizeof(char), 4, thefile );
	fread( &thedata->numWBBlocks, sizeof(unsigned long), 1, thefile );
	fread( thedata->data1, sizeof(char), 8, thefile );
	fread( &thedata->fileSize, sizeof(unsigned long), 1, thefile );
	fread( &thedata->numWTEs, sizeof(unsigned long), 1, thefile );

	thedata->WBTable = new struct WTE * [thedata->numWTEs];

	for(unsigned int i=0; i < thedata->numWTEs; i++)
	{
		thedata->WBTable[i] = new struct WTE;
		fread( thedata->WBTable[i]->data1, sizeof(char), 4, thefile );
		fread( &thedata->WBTable[i]->blockOffset, sizeof(unsigned long), 1, thefile );
		fread( &thedata->WBTable[i]->blockLength, sizeof(unsigned long), 1, thefile );
		fread( thedata->WBTable[i]->data2, sizeof(char), 8, thefile );
		fread( thedata->WBTable[i]->tag, sizeof(char), 8, thefile );
		fread( &thedata->WBTable[i]->WBHLength, sizeof(unsigned long), 1, thefile);
		fread( &thedata->WBTable[i]->adpBlkLen, sizeof(unsigned long), 1, thefile );
		fread( &thedata->WBTable[i]->dataLength, sizeof(unsigned long), 1, thefile );
		fread( &thedata->WBTable[i]->unCompLen, sizeof(unsigned long), 1, thefile );
		fread( &thedata->WBTable[i]->sampRate, sizeof(unsigned long), 1, thefile );
		fread( &thedata->WBTable[i]->numBits, sizeof(char), 1, thefile );
		fread( &thedata->WBTable[i]->numChans, sizeof(char), 1, thefile );
		fread( &thedata->WBTable[i]->codeFormat, sizeof(char), 1, thefile );
		fread( &thedata->WBTable[i]->data6, sizeof(char), 1, thefile );
		fread( thedata->WBTable[i]->data7, sizeof(char), 4, thefile );
	}

	for (i=0; i < thedata->numWTEs; i++)
	{
		fseek(thefile, thedata->WBTable[i]->blockOffset, SEEK_SET);
		fseek(thefile, 0x024, SEEK_CUR);

		thedata->WBTable[i]->extraData = new unsigned char [thedata->WBTable[i]->WBHLength - 0x024];
		fread(thedata->WBTable[i]->extraData, sizeof(char), thedata->WBTable[i]->WBHLength - 0x024, thefile);
	}

	return 0;
}

int load_WBBlock(FILE *thefile, struct TPAFILE *thedata, unsigned int blockNum, struct WBBLOCK *theblock)
{
	unsigned long offset = thedata->WBTable[blockNum]->blockOffset;
	unsigned long dLength = thedata->WBTable[blockNum]->dataLength;

	fseek(thefile, offset, SEEK_SET);

	fread( theblock->WBH->tag, sizeof(char), 8, thefile );
	fread( &theblock->WBH->WBHLength, sizeof(unsigned long), 1, thefile);
	fread( &theblock->WBH->adpBlkLen, sizeof(unsigned long), 1, thefile );
	fread( &theblock->WBH->dataLength, sizeof(unsigned long), 1, thefile );
	fread( &theblock->WBH->unCompLen, sizeof(unsigned long), 1, thefile );
	fread( &theblock->WBH->sampRate, sizeof(long), 1, thefile );
	fread( &theblock->WBH->numBits, sizeof(char), 1, thefile );
	fread( &theblock->WBH->numChans, sizeof(char), 1, thefile );
	fread( &theblock->WBH->codeFormat, sizeof(char), 1, thefile );
	fread( &theblock->WBH->data6, sizeof(char), 1, thefile );
	fread( theblock->WBH->data7, sizeof(char), 4, thefile );
	theblock->WBH->extraData = new unsigned char [theblock->WBH->WBHLength - 0x024];
	fread( theblock->WBH->extraData, sizeof(char), theblock->WBH->WBHLength - 0x024, thefile);

	//should error check around here... eh, whatever... later :)

	theblock->WBD = new unsigned char [dLength];
	fread( theblock->WBD, sizeof(unsigned char), dLength, thefile);

	return 0;
}


#define BUFFERSIZE 4096	// Size of cluster in Fat32

int extract_WBBlock(FILE *infile, struct TPAFILE *thedata, unsigned int blockNum, FILE *outfile)
{
	unsigned long offset = thedata->WBTable[blockNum]->blockOffset;
	unsigned long dLength = thedata->WBTable[blockNum]->dataLength;
	unsigned long WBHLen = thedata->WBTable[blockNum]->WBHLength;

	unsigned char buffer[BUFFERSIZE];

	fseek(infile, offset, SEEK_SET);
	fseek(infile, WBHLen, SEEK_CUR);	// skip header... 

	for(int i=0; i < floor(dLength/BUFFERSIZE); i++)
	{
		fread( buffer, sizeof(char), BUFFERSIZE, infile );
		fwrite( buffer, sizeof(char), BUFFERSIZE, outfile );
	}

	fread( buffer, sizeof(char), dLength % BUFFERSIZE, infile );
	fwrite( buffer, sizeof(char), dLength % BUFFERSIZE, outfile );

	return 0;
}