#ifndef _TPAHACK_H
#define _TPAHACK_H

struct WTE
{
	unsigned char data1[4];
	unsigned long blockOffset;
	unsigned long blockLength;
	unsigned char data2[8];
	unsigned char tag[8];
	unsigned long WBHLength;
	unsigned long adpBlkLen;
	unsigned long dataLength;
	unsigned long unCompLen;
	unsigned long sampRate;
	unsigned char numBits;
	unsigned char numChans;
	unsigned char codeFormat;
	unsigned char data6;
	unsigned char data7[4];
	unsigned char *extraData;
};

struct TPAFILE
{
	unsigned char tag[4];
	unsigned long numWBBlocks;
	unsigned char data1[8];
	unsigned long fileSize;
	unsigned long numWTEs;

	struct WTE **WBTable;
};


struct _WBH
{
	unsigned char tag[8];
	unsigned long WBHLength;
	unsigned long adpBlkLen;
	unsigned long dataLength;
	unsigned long unCompLen;
	unsigned char sampRate;
	unsigned char numBits;
	unsigned char numChans;
	unsigned char codeFormat;
	unsigned char data6;
	unsigned char data7[4];
	unsigned char *extraData;
};


struct WBBLOCK
{ 
	struct _WBH *WBH;
	unsigned char *WBD;
};

struct PCMWAVE
{
	unsigned long	riffTag;		// "RIFF"
	unsigned long	length;			// For PCM, DataLen+36
	unsigned long	waveTag;		// "WAVE"
	unsigned long	fmtTag;			// "fmt "
	unsigned long	fmtLen;			// For PCM = 16
	unsigned short	encodingTag;	// For PCM = 1
	unsigned short	numChans;
	unsigned long	sampRate;
	unsigned long	dataRate;
	unsigned short	blockAlign;		// numChan*bitsSamp/8
	unsigned short	bitsSamp;		// Bits per sample
	unsigned long	dataTag;		// "data"
	unsigned long	dataLen;
};

struct ADPCMWAVE
{
	unsigned long	riffTag;		// "RIFF"
	unsigned long	length;			// For IMA ADPCM, DataLen+
	unsigned long	waveTag;		// "WAVE"
	unsigned long	fmtTag;			// "fmt "
	unsigned long	fmtLen;			// For IMA ADPCM = 0x14
	unsigned short	encodingTag;	// For IMA ADPCM = 0x11
	unsigned short	numChans;		// Number of Channels
	unsigned long	sampRate;		// Sample Rate
	unsigned long	dataRate;		// ?? It was never made clear
	unsigned short	adpBlkLen;		// numChan*bitsSamp/8
	unsigned short	bitsSamp;		// Bits per sample
	unsigned short	cbSize;			// Size of extra data 2 for IMA ADPCM
	unsigned short	sampPerBlk;		// ((adpBlkLen / (4*numChan))-1)*4
	unsigned long	factTag;		// "fact"
	unsigned long	factBits;		// The fact chunk stinks IMO
	unsigned long	unCompLen;		// Uncompressed length
	unsigned long	dataTag;		// "data"
	unsigned long	dataLen;
};

// The Data Rate for ADPCM wave files is not what kills MPLAYER.
// What gets it is the sampPerBlk, it's too big for the Win95 driver.




int is_good_tpa(FILE *);
int load_tpa_data(FILE *, struct TPAFILE *);
int load_WBBlock(FILE *, struct TPAFILE *, unsigned int, struct WBBLOCK *);
int extract_WBBlock(FILE *, struct TPAFILE *, unsigned int, FILE *);

#endif
